global gui var
proc showpopup {} {
    global  mnu
    set numx [winfo pointerx .]
    set numy [winfo pointery .]
    tk_popup $mnu(edit) $numx $numy
}
proc text_bindings {} {
    global gui
    #bind $gui(text) <Button-2> {showpopup}
    bind $gui(text) <Button-3> showpopup
}


# Edit -- Cut

$mnu(edit) add command -label "Cut" -underline 2 \
	-command cut_text -accelerator Ctrl+x
# binding <Control-x> is built-in

proc cut_text {} {
    global gui
    tk_textCut $gui(text)
    $gui(text) edit separator
}

# Edit -- Copy

$mnu(edit) add command -label "Copy" -underline 0 \
          -command copy_text -accelerator Ctrl+c
# binding <Control-c> is built-in

proc copy_text {} {
    global gui
    tk_textCopy $gui(text)
    $gui(text) edit separator
}

# Edit -- Paste

$mnu(edit) add command -label "Paste" -underline 0 \
          -command paste_text -accelerator Ctrl+g

proc paste_text {} {
    global gui
    tk_textPaste $gui(text)
    $gui(text) edit separator
    $gui(text) see insert
}

bind . <Control-g> paste_text
# This binding isn't built in.
# <Control-v> didn't work quite right--I don't know why.

# Edit -- Delete

$mnu(edit) add command -label "Delete" -underline 0 \
          -command "$gui(text) delete sel.first sel.last" -accelerator Del

proc delete_text {} {
    global gui
    $gui(text) delete sel.first sel.last
    $gui(text) edit separator
}

$mnu(edit) add separator

# Edit -- Undo

$mnu(edit) add command -label "Undo" -underline 0 -command {
    catch {	$gui(text) edit undo }
} -accelerator Ctrl+z
# Binding Ctrl+z is built in

# Edit -- Redo

$mnu(edit) add command -label "Redo" -underline 0 \
          -command { catch {$gui(text) edit redo} } -accelerator Ctrl+r

bind . <space> {$gui(text) edit separator}
bind . <BackSpace> {$gui(text) edit separator}

$mnu(edit) add separator

# Edit -- Select All

$mnu(edit) add command -label "Select all" -underline 7 \
          -command "$gui(text) tag add sel 1.0 end" -accelerator Ctrl+/
# binding <Control-/> is built-in

# Edit -- Word Wrap

$mnu(edit) add checkbutton -variable wordwrap \
          -label "Word wrap" -onvalue word -offvalue none \
          -underline 0 -selectcolor #ff0000 -command wraponoroff

proc wraponoroff {} {
    global gui
    global wordwrap
    if { $wordwrap == "none" } {
        $gui(text) configure -wrap none
    } else {
        $gui(text) configure -wrap word
    }
}
