
proc search_and_replace_init {mnu text} {
    global sgui
    set sgui(text) $text
    $mnu  add command -label "Find" -underline 0 -command "findtext find" -accelerator Ctrl-f
    $mnu add command -label "Find Next" -underline 1 -command "findnext find" -accelerator F3
    $mnu add command -label "Replace" -underline 0 -command "findtext replace" -accelerator Ctrl-r
    $mnu add separator
    $mnu add command -label "Goto Line" -underline 0 -command "gotoline" -accelerator Ctrl-g
    bind all <Control-f> {findtext find}
    bind all <Key-F3> {findnext find}
    bind all <Control-r> {findtext replace}
    bind all <Control-g> {gotoline}
    set svar(replacements) 0
    
}
proc gotoline {} {
	set gotln .gotln
	catch {destroy $gotln}
	toplevel $gotln
	wm title $gotln "Goto Line?"
	setwingeom $gotln
	frame $gotln.top 
	frame $gotln.bottom
	label $gotln.top.label -text "Goto Line: "
	entry $gotln.top.gotln -textvariable gotlnsetupnew -width 10
	$gotln.top.gotln delete 0 end 
	button $gotln.bottom.ok -text "OK" -command "addtogotln $gotln"
	button $gotln.bottom.cancel -text "Cancel" -command "destroy $gotln"
	focus $gotln.top.gotln
	pack $gotln.top -side top -expand 0 
	pack $gotln.bottom -side bottom -expand 0 
	pack $gotln.top.label $gotln.top.gotln -in $gotln.top -side left -fill x -fill y
	pack $gotln.bottom.ok $gotln.bottom.cancel -in $gotln.bottom -side left -fill x -fill y
	bind $gotln <Return> "addtogotln $gotln"
	bind $gotln <Escape> "destroy $gotln"

    proc addtogotln {prnt} {
         global gotlnCommand sgui
         set gotlnCommand [$prnt.top.gotln get]
         $sgui(text) mark set insert "$gotlnCommand.0"
         $sgui(text) yview "$gotlnCommand.0"
         catch {keyposn}
         destroy $prnt
    }
}

proc search_set_text { text } {
    global sgui
    set sgui(text) $text
}
proc findtext {typ} {
    global svar
	#global SearchString SearchDir ReplaceString findcase c find
	set svar(find) .find
	catch {destroy $svar(find)}
	toplevel $svar(find)
	wm title $svar(find) "Find"
	setwingeom $svar(find)
	ResetFind
	frame $svar(find).l
	frame $svar(find).l.f1
	label $svar(find).l.f1.label -text "Find what:" -width 11  
	entry $svar(find).l.f1.entry  -textvariable svar(SearchString) -width 30 
	pack $svar(find).l.f1.label $svar(find).l.f1.entry -side left
	$svar(find).l.f1.entry selection range 0 end
	if {$typ=="replace"} {
		frame $svar(find).l.f2
		label $svar(find).l.f2.label2 -text "Replace with:" -width 11
		entry $svar(find).l.f2.entry2  -textvariable svar(ReplaceString) -width 30 
		pack $svar(find).l.f2.label2 $svar(find).l.f2.entry2 -side left
		pack $svar(find).l.f1 $svar(find).l.f2 -side top
	} else {
		pack $svar(find).l.f1
	}
	frame $svar(find).f2
	button $svar(find).f2.button1 -text "Find Next" -command "FindIt $svar(find)" -width 10 -height 1 -underline 5 
	button $svar(find).f2.button2 -text "Cancel" -command "CancelFind $svar(find)" -width 10 -underline 0
	if {$typ=="replace"} {
		button $svar(find).f2.button3 -text "Replace" -command ReplaceIt -width 10 -height 1 -underline 0
		button $svar(find).f2.button4 -text "Replace All" -command ReplaceAll -width 10 -height 1 -underline 8		
		pack $svar(find).f2.button3 $svar(find).f2.button4 $svar(find).f2.button2  -pady 4
	} else {
		pack $svar(find).f2.button1 $svar(find).f2.button2  -pady 4
	}
	frame $svar(find).l.f4
	frame $svar(find).l.f4.f3 -borderwidth 2 -relief groove
	radiobutton $svar(find).l.f4.f3.up -text "Up" -underline 0 -variable svar(SearchDir) -value "backwards" 
	radiobutton $svar(find).l.f4.f3.down -text "Down"  -underline 0 -variable svar(SearchDir) -value "forwards" 
	$svar(find).l.f4.f3.down invoke
	pack $svar(find).l.f4.f3.up $svar(find).l.f4.f3.down -side left 
	checkbutton $svar(find).l.f4.cbox1 -text "Match case" -variable svar(findcase) -underline 0 
	pack $svar(find).l.f4.cbox1 $svar(find).l.f4.f3 -side left -padx 10
	pack $svar(find).l.f4 -pady 11
	pack $svar(find).l $svar(find).f2 -side left -padx 1
	bind $svar(find) <Escape> "destroy $svar(find)"

     # each widget must be bound to th eevents of the other widgets
     proc bindevnt {widgetnm types find} {
	if {$types=="replace"} {
		bind $widgetnm <Return> "ReplaceIt"
		bind $widgetnm <Control-r> "ReplaceIt"
		bind $widgetnm <Control-a> "ReplaceAll"
	} else {
		bind $widgetnm <Return> "FindIt $find"
		bind $widgetnm <Control-n> "FindIt $find"
	}
	bind $widgetnm <Control-m> { $find.l.f4.cbox1 invoke }
	bind $widgetnm <Control-u> { $find.l.f4.f3.up invoke }
	bind $widgetnm <Control-d> { $find.l.f4.f3.down invoke }
     }
	if {$typ == "replace"} {
   		bindevnt $svar(find).f2.button3 $typ $svar(find)
		bindevnt $svar(find).f2.button4 $typ $svar(find)
	} else {
		bindevnt $svar(find).f2.button1 $typ $svar(find)
  	        bindevnt $svar(find).f2.button2 $typ $svar(find)
	}
        bindevnt $svar(find).l.f4.f3.up  $typ $svar(find)
        bindevnt $svar(find).l.f4.f3.down $typ $svar(find)
        bindevnt $svar(find).l.f4.cbox1 $typ $svar(find)
	bindevnt $svar(find).l.f1.entry $typ $svar(find)	
	bind $svar(find) <Control-c> "destroy $svar(find)"
	focus $svar(find).l.f1.entry
	#grab $svar(find)
}

# proc for find next
proc findnext {typof} {
	global svar ;#SearchString SearchDir ReplaceString findcase c find
	if [catch {expr [string compare $svar(SearchString) "" ] }] {
		findtext $typof
	} else {
	 	FindIt $svar(find)
	}
}
proc setwingeom {wintoset} {
    wm resizable $wintoset 0 0
    set myx [expr (([winfo screenwidth .]/2) - ([winfo reqwidth $wintoset]))]
    set myy [expr (([winfo screenheight .]/2) - ([winfo reqheight $wintoset]/2))]
    wm geometry $wintoset +$myx+$myy
}

proc FindIt {w} {
    global sgui svar
    #global SearchString SearchPos SearchDir findcase 
    $sgui(text) tag configure sel -background green
    if {$svar(SearchString)!=""} {
        if {$svar(findcase)=="1"} {
            set caset "-exact"
        } else {
            set caset "-nocase"
        }
        if {$svar(SearchDir) == "forwards"} {
            set limit end
        } else {
            set limit 1.0
        }
        set svar(SearchPos) [ $sgui(text) search -count len $caset -$svar(SearchDir) $svar(SearchString) $svar(SearchPos) $limit]
        set len [string length $svar(SearchString)]
        if {$svar(SearchPos) != ""} {
            $sgui(text) see $svar(SearchPos)
            $sgui(text) mark set insert $svar(SearchPos)
            #tkTextSetCursor $sgui(text) $svar(SearchPos)
            $sgui(text) tag add sel $svar(SearchPos)  "$svar(SearchPos) + $len char"
            
            if {$svar(SearchDir) == "forwards"} {
                set svar(SearchPos) "$svar(SearchPos) + $len char"
            }         
        } else {
            tk_messageBox -title "Found ?" -icon info -message "Not found !" -type ok
            set svar(SearchPos) "0.0"
        }
    }
    focus $sgui(text)
}

proc CancelFind {w} {
    global sgui
    $sgui(text) tag delete tg1
    destroy $w
}

proc ResetFind {} {
    global svar
    set svar(SearchPos) insert
}

proc ReplaceAll {} {
    global svar
    set svar(replacements) 0
       if {$svar(SearchString) != ""} {
                ReplaceIt
	while {$svar(SearchPos)!="0.0"} {
		ReplaceIt
	}
    }
    tk_messageBox -title "Info!" -icon info -message " $svar(replacements) replacements done!" -type ok
}
proc ReplaceIt {} {
    global svar sgui
    if {$svar(SearchString) != ""} {
        if {$svar(findcase)=="1"} {
            set caset "-exact"
        } else {
            set caset "-nocase"
        }
        if {$svar(SearchDir) == "forwards"} {
            set limit end
        } else {
            set limit 1.0
        }
        set svar(SearchPos) [ $sgui(text) search -count len $caset -$svar(SearchDir) $svar(SearchString) $svar(SearchPos) $limit]
        set len [string length $svar(SearchString)]
        if {$svar(SearchPos) != ""} {
            $sgui(text) see $svar(SearchPos)
            $sgui(text) delete $svar(SearchPos) "$svar(SearchPos)+$len char"
            $sgui(text) insert $svar(SearchPos) $svar(ReplaceString)
            incr svar(replacements)
            if {$svar(SearchDir) == "forwards"} {
                set svar(SearchPos) "$svar(SearchPos)+$len char"
            }         
        } else {
            set svar(SearchPos) "0.0"
        }
    }
	
}
